"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UIServerConsole = void 0;
const react_1 = __importStar(require("react"));
const ink_1 = require("ink");
const ui_foundation_cli_ui_server_loader_1 = require("@teambit/ui-foundation.cli.ui-server-loader");
function UIServerConsole({ appName, futureUiServer, url }) {
    const [uiServer, setUiServer] = (0, react_1.useState)();
    const [uiServerReady, setUiServerReady] = (0, react_1.useState)(false);
    const [plugins, setPlugins] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        futureUiServer
            .then((server) => __awaiter(this, void 0, void 0, function* () {
            setUiServer(server);
            setPlugins(server.getPluginsComponents());
            yield server.whenReady;
            setUiServerReady(true);
        }))
            .catch((err) => {
            throw err;
        });
    }, []);
    if (!uiServer)
        return react_1.default.createElement(ui_foundation_cli_ui_server_loader_1.UIServerLoader, { name: appName });
    return (react_1.default.createElement(react_1.default.Fragment, null, plugins === null || plugins === void 0 ? void 0 :
        plugins.map((Plugin, key) => {
            return react_1.default.createElement(Plugin, { key: key });
        }),
        uiServerReady && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(ink_1.Newline, null),
            react_1.default.createElement(ink_1.Text, null,
                "You can now view '",
                react_1.default.createElement(ink_1.Text, { color: "cyan" }, uiServer === null || uiServer === void 0 ? void 0 : uiServer.getName()),
                "' components in the browser."),
            react_1.default.createElement(ink_1.Text, null,
                "Bit server is running on ",
                url || uiServer.fullUrl)))));
}
exports.UIServerConsole = UIServerConsole;
//# sourceMappingURL=ui-server-console.js.map